import csv
import json
import os
import pprint
from pathlib import Path

from pyspark.sql import Row, SparkSession
from pyspark.sql.connect.dataframe import DataFrame
from pyspark.testing.utils import assertDataFrameEqual

from biocloudcore.utils.test_tools.test_dataset import CsvTestDataset, JsonTestDataset, TestDataset


def assert_compare_output(
    output: DataFrame | list[Row] | list[dict], output_test: DataFrame | list[dict], recursive: bool = False
):
    """
    Basic test to assert if an output and another dataframe or a list of dictionaries have the same content.

    :param output: The DataFrame or dict to evaluate
    :param output_test: Expected output
    :raises AssertionError: Expected output was not equal to the actual input
    :raises TypeError: Invalid input given to the function
    """

    # parse output generated by logic
    print("Processed output")
    if isinstance(output, DataFrame):
        output.show(truncate=False)
        output_dict = [d.asDict(recursive) for d in output.collect()]
    elif isinstance(output, list):
        pprint.pprint(output)
        if output[0].isinstance(Row):
            output_dict = [d.asDict(recursive) for d in output]
        elif output[0].isinstance(dict):
            output_dict = output
        else:
            raise TypeError(f"If output is a list, list item should be Row or dict, not {type(output[0])}")
    else:
        raise TypeError(f"output should be list or dataframe, not {type(output)}")

    # parse reference data
    if isinstance(output_test, DataFrame):
        output_test_dict = [d.asDict(recursive) for d in output_test.collect()]
    elif isinstance(output_test, list):
        output_test_dict = output_test
    else:
        raise TypeError(f"output_test should be list or dataframe, not {type(output_test)}")

    # Compare processed and reference data
    print(f"Equal rows? {len(output_dict)=} == {len(output_test_dict)=}")
    assert len(output_dict) == len(output_test_dict)

    print("Output data")
    pprint.pprint(output_dict)

    print("Assert all data in test output in output")
    for item in output_test_dict:
        pprint.pprint(item)
        assert item in output_dict

    print("Assert all data in output in test output")
    assert assertDataFrameEqual(actual=output, excepted=output_test)
    # all([i in output_test_dict for i in output_dict])


def persist_datasets_to_delta(spark: SparkSession, directory: Path, test_datasets: list[TestDataset]) -> None:
    """
    Helper function to persist datasets to delta.  One delta table per dataset.

    :param spark: Spark session
    :param directory: path of the directory where the files should be stored
    :param test_datasets: list of datasets
    """
    for dataset in test_datasets:
        file = os.path.join(directory, dataset.filename)
        data = [tuple(row.values()) for row in dataset.data]
        df = spark.createDataFrame(data, dataset.schema)
        df.write.mode("overwrite").format("delta").save(file)


def persist_datasets_to_parquet(spark: SparkSession, directory: Path, test_datasets: list[TestDataset]) -> None:
    """
    Helper function to persist datasets to parquet.  One parquet file per dataset.

    :param spark: Spark session
    :param directory: path of the directory where the files should be stored
    :param test_datasets: list of datasets
    """
    for dataset in test_datasets:
        file = os.path.join(directory, dataset.filename)
        data = [tuple(row.values()) for row in dataset.data]
        df = spark.createDataFrame(data, dataset.schema)
        df.write.mode("overwrite").format("parquet").option("overwriteSchema", "true").save(file)


def persist_datasets_to_avro(spark: SparkSession, directory: Path, test_datasets: list[TestDataset]) -> None:
    """
    Helper function to persist datasets to avro.  One avro file per dataset.

    :param spark: Spark session
    :param directory: path of the directory where the files should be stored
    :param test_datasets: list of datasets
    """

    # Create data
    for dataset in test_datasets:
        # Serialize dataset to binary JSONs to serve as values for the Avro 'Body'
        avro_data = [(json.dumps(x).encode(),) for x in dataset.data]

        # Create new dataframe using the Avro schema and persist it as an Avro file
        dest_file = os.path.join(directory, dataset.filename)
        df = spark.createDataFrame(avro_data, dataset.schema)
        df.write.format("avro").save(dest_file)


def persist_datasets_to_csv(directory: Path, test_datasets: list[CsvTestDataset], delimiter: str) -> None:
    """
    Helper function to persist datasets to CSV.  One CSV file per dataset.

    :param directory: location where to write the CSV files
    :param test_datasets: datasets defined by their content and the CSV filenames to store the content
    :param delimiter: delimiter to use in CSV file to separate values
    """
    for dataset in test_datasets:
        dest_file = os.path.join(directory, dataset.filename)
        with open(dest_file, "w", encoding="UTF8", newline="") as csv_file:
            writer = csv.DictWriter(csv_file, fieldnames=dataset.header, delimiter=delimiter)
            writer.writeheader()
            writer.writerows(dataset.data)


def persist_datasets_to_json(directory: Path, test_datasets: list[JsonTestDataset]) -> None:
    """
    Helper function to persist datasets to JSON formatted text files.  One JSON file per dataset.

    :param directory: location where to write the JSON formatted text files
    :param test_datasets: list of datasets defined by their content to format as JSON and the filenames to use to store
    """
    for dataset in test_datasets:
        dest_file = os.path.join(directory, dataset.filename)
        with open(dest_file, "w") as json_file:
            json.dump(dataset.data, json_file)
